package com.jojubanking.boot.module.system.service.mzdm;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;

import java.util.*;
import com.jojubanking.boot.module.system.controller.admin.mzdm.vo.*;
import com.jojubanking.boot.module.system.dal.dataobject.mzdm.MzdmDO;
import com.jojubanking.boot.framework.common.pojo.PageResult;

import com.jojubanking.boot.module.system.convert.mzdm.MzdmConvert;
import com.jojubanking.boot.module.system.dal.mysql.mzdm.MzdmMapper;

import static com.jojubanking.boot.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.jojubanking.boot.module.system.enums.ErrorCodeConstants.*;

/**
 * 民族代码 Service 实现类
 *
 * @author admin
 */
@Service
@Validated
public class MzdmServiceImpl implements MzdmService {

    @Resource
    private MzdmMapper mzdmMapper;

    @Override
    public Long createMzdm(MzdmCreateReqVO createReqVO) {
        // 插入
        MzdmDO mzdm = MzdmConvert.INSTANCE.convert(createReqVO);
        mzdmMapper.insert(mzdm);
        // 返回
        return mzdm.getId();
    }

    @Override
    public void updateMzdm(MzdmUpdateReqVO updateReqVO) {
        // 校验存在
        this.validateMzdmExists(updateReqVO.getId());
        // 更新
        MzdmDO updateObj = MzdmConvert.INSTANCE.convert(updateReqVO);
        mzdmMapper.updateById(updateObj);
    }

    @Override
    public void deleteMzdm(Long id) {
        // 校验存在
        this.validateMzdmExists(id);
        // 删除
        mzdmMapper.deleteById(id);
    }

    private void validateMzdmExists(Long id) {
        if (mzdmMapper.selectById(id) == null) {
            throw exception(MZDM_NOT_EXISTS);
        }
    }

    @Override
    public MzdmDO getMzdm(Long id) {
        return mzdmMapper.selectById(id);
    }

    @Override
    public List<MzdmDO> getMzdmList(Collection<Long> ids) {
        return mzdmMapper.selectBatchIds(ids);
    }

    @Override
    public PageResult<MzdmDO> getMzdmPage(MzdmPageReqVO pageReqVO) {
        return mzdmMapper.selectPage(pageReqVO);
    }

    @Override
    public List<MzdmDO> getMzdmList(MzdmExportReqVO exportReqVO) {
        return mzdmMapper.selectList(exportReqVO);
    }
    @Override
    public List<MzdmDO> getMzdmList01(MzdmExportReqVO exportReqVO) {
        return mzdmMapper.selectList01(exportReqVO);
    }

}
